#include QMK_KEYBOARD_H

extern keymap_config_t keymap_config;

#define _QWERTY 0
#define _GAMER 1
#define _RETRO_GAMER 2
#define _LEFT 3
#define _RIGHT 4
#define _ADJUST 5
#define _CONFIG 6

#define ESC_CTL LCTL_T(KC_ESC)

enum custom_keycodes {
  QWERTY = SAFE_RANGE,
  GAMER,
  RETRO_GAMER,
  LEFT,
  RIGHT,
  ADJUST,
  CONFIG,
	PADJUST,
};

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {

  [_QWERTY] = LAYOUT(
     KC_GRV,  KC_1,    KC_2,    KC_3,    KC_4,    KC_5,                               KC_6,    KC_7,    KC_8,    KC_9,    KC_0,    KC_BSPC,
     KC_TAB,  KC_Q,    KC_W,    KC_E,    KC_R,    KC_T,                               KC_Y,    KC_U,    KC_I,    KC_O,    KC_P,    KC_BSPC,
     ESC_CTL, KC_A,    KC_S,    KC_D,    KC_F,    KC_G,                               KC_H,    KC_J,    KC_K,    KC_L,    KC_SCLN, KC_QUOT,
     KC_LSFT, KC_Z,    KC_X,    KC_C,    KC_V,    KC_B,    XXXXXXX,        MO(_CONFIG),KC_N,  KC_M,    KC_COMM, KC_DOT,  KC_SLSH, KC_ENT,
                                    KC_LGUI, KC_SPC, MO(_LEFT),                 MO(_RIGHT),KC_SPC,  KC_LALT
  ),

  [_GAMER] = LAYOUT(
     KC_ESC,  _______, _______, _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
     _______, _______, _______, _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
     KC_LCTL, _______, _______, _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
     _______, _______, _______, _______, _______, _______, _______,          _______, _______, _______, _______, _______, _______, _______,
                                    _______, _______, _______,                   _______, _______, _______
  ),

  [_RETRO_GAMER] = LAYOUT(
     KC_ESC,  _______, _______, _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
     _______, _______, KC_UP,   _______, _______, _______,                            _______, _______, _______, _______, _______, _______,
     KC_LCTL, KC_LEFT, KC_DOWN, KC_RGHT, _______, _______,                            _______, _______, _______, _______, _______, _______,
     _______, _______, _______, _______, _______, _______, _______,          _______, _______, _______, _______, _______, _______, _______,
                                    _______, _______, _______,                   _______, _______, _______
  ),

  [_LEFT] = LAYOUT(
     KC_F1,   KC_F2,   KC_F3,   KC_F4,   KC_F5,   KC_F6,                              KC_F7,   KC_F8,   KC_F9,   KC_F10,  KC_F11,  KC_F12,
     KC_TILD, KC_EXLM, KC_AT,   KC_HASH, KC_DLR,  KC_PERC,                            KC_CIRC, KC_AMPR, KC_ASTR, KC_LPRN, KC_RPRN, KC_BSPC,
     _______, _______, _______, _______, _______, _______,                            _______, KC_UNDS, KC_PLUS, KC_LCBR, KC_RCBR, KC_PIPE,
     _______, _______, _______, _______, _______, _______, _______,          _______, _______, _______, KC_LT,   KC_GT,   KC_QUES, _______,
                                    _______, _______, _______,                 MO(_ADJUST),KC_ENT, _______
  ),

  [_RIGHT] = LAYOUT(
     KC_ESC,  KC_EXLM, KC_AT,   KC_HASH, KC_DLR,  KC_PERC,                            KC_CIRC, KC_AMPR, KC_ASTR, KC_LPRN, KC_RPRN, KC_DEL,
     KC_GRV,  KC_1,    KC_2,    KC_3,    KC_4,    KC_5,                               KC_6,    KC_7,    KC_8,    KC_9,    KC_0,    KC_DEL,
     _______, _______, _______, _______, _______, _______,                            _______, KC_MINS, KC_EQL,  KC_LBRC, KC_RBRC, KC_BSLS,
     _______, _______, _______, _______, KC_INS,  _______, _______,          _______, _______, KC_INS,  _______, _______, _______, _______,
                                    _______, KC_LALT,MO(_ADJUST),                 _______, _______, _______
  ),

  [_ADJUST] = LAYOUT(
     _______, KC_ACL0, KC_ACL1, KC_ACL2, _______, _______,                            _______, _______, _______, _______, _______, _______,
     _______, KC_BTN1, KC_MS_U, KC_BTN2, KC_WH_U, _______,                            KC_MPRV, KC_VOLD, KC_MPLY, KC_VOLU, KC_MNXT, _______,
     _______, KC_MS_L, KC_MS_D, KC_MS_R, KC_WH_D, _______,                            KC_LEFT, KC_DOWN, KC_UP,   KC_RGHT, _______, _______,
     _______, _______, _______, _______, _______, _______, _______,          _______, KC_HOME, KC_PGDN, KC_PGUP, KC_END,  _______, _______,
                                    _______, _______, _______,                   _______, _______, _______
  ),

  [_CONFIG] = LAYOUT(
     RESET,   _______, _______, _______, _______, RGB_TOG,                            _______, _______, _______, _______, _______, RESET,
     _______, _______, _______, _______, _______, RGB_MOD,                            _______, _______, _______, _______, _______, _______,
     _______, _______, _______, RGB_HUI, RGB_SAI, RGB_VAI,                            _______, _______, _______, _______, _______, _______,
     _______, _______, _______, RGB_HUD, RGB_SAD, RGB_VAD, _______,          _______, _______, _______, _______, _______, _______, _______,
                                    PADJUST, QWERTY,  RGB_TOG,                   _______, GAMER,  RETRO_GAMER
  )
};

bool process_record_user(uint16_t keycode, keyrecord_t *record) {
  switch (keycode) {
    case GAMER:
			rgblight_enable_noeeprom();
			rgblight_sethsv_noeeprom(HSV_RED);
      if (record->event.pressed) {
        set_single_persistent_default_layer(_GAMER);
      }
      return false;
      break;
    case RETRO_GAMER:
			rgblight_enable_noeeprom();
			rgblight_sethsv_noeeprom(HSV_YELLOW);
      if (record->event.pressed) {
        set_single_persistent_default_layer(_RETRO_GAMER);
      }
      return false;
      break;
    case QWERTY:
			rgblight_enable_noeeprom();
			rgblight_sethsv_noeeprom(HSV_BLUE);
      if (record->event.pressed) {
        set_single_persistent_default_layer(_QWERTY);
      }
      return false;
      break;
    case LEFT:
      if (record->event.pressed) {
        layer_on(_LEFT);
        update_tri_layer(_LEFT, _RIGHT, _ADJUST);
      } else {
        layer_off(_LEFT);
        update_tri_layer(_LEFT, _RIGHT, _ADJUST);
      }
      return false;
      break;
    case RIGHT:
      if (record->event.pressed) {
        layer_on(_RIGHT);
        update_tri_layer(_LEFT, _RIGHT, _ADJUST);
      } else {
        layer_off(_RIGHT);
        update_tri_layer(_LEFT, _RIGHT, _ADJUST);
      }
      return false;
      break;
    case ADJUST:
      if (record->event.pressed) {
        layer_on(_ADJUST);
      } else {
        layer_off(_ADJUST);
      }
      return false;
      break;
    case PADJUST:
			rgblight_enable_noeeprom();
			rgblight_sethsv_noeeprom(HSV_GREEN);
      if (record->event.pressed) {
        set_single_persistent_default_layer(_ADJUST);
      }
      return false;
      break;
  }
  return true;
}

void encoder_update_user(uint8_t index, bool clockwise) {
    if (index == 0) {
        if (clockwise) {
            tap_code(KC_VOLU);
        } else {
            tap_code(KC_VOLD);
        }
    }
    else if (index == 1) {
        if (clockwise) {
            tap_code(KC_PGDN);
        } else {
            tap_code(KC_PGUP);
        }
    }
}
