#!/usr/bin/env fish

test (whoami) != root && begin
	echo must be root
	exit 1
end

set flash_target /dev/disk/by-label/NICENANO
set firmware_file $argv[1]

mkdir -p /tmp/flashmnt
while not test -L $flash_target
	echo Waiting for mountable device $flash_target to become available...
	echo "  This usually means you need to plugin the board and reset it."
	sleep 1
end

echo Mounting $flash_target to /tmp/flashmnt...
mount $flash_target /tmp/flashmnt

echo Copying $firmware_file to /tmp/flashmnt...
cp $firmware_file /tmp/flashmnt

echo Syncing...
sync

echo Unmounting /tmp/flashmnt...
umount -R /tmp/flashmnt

echo Done!
